﻿
local _G=_G
local strmatch,tonumber,format,debugprofilestop,table,tinsert,select,type,pairs,gsub,tostring = 
      strmatch,tonumber,format,debugprofilestop,table,tinsert,select,type,pairs,gsub,tostring
local max = 
      max
local EnumerateFrames, GetFrameCPUUsage,InCombatLockdown = 
	  EnumerateFrames, GetFrameCPUUsage,InCombatLockdown
	  
--GLOBALS: CPUThievesDB

local outputFrame = ChatFrame1

local printtmp = {"CPUThieves:"}
local function print(msgOrFrame,...)
	local frame
	local n=1
	if (type(msgOrFrame)=="table" and msgOrFrame.AddMessage) or msgOrFrame==nil then
		frame=msgOrFrame
	else
		n=n+1;printtmp[n]=msgOrFrame
	end
	if not frame then
		frame = _G.SELECTED_CHAT_FRAME or _G.DEFAULT_CHAT_FRAME
	end
	for i=1,select("#",...) do
		n=n+1;printtmp[n]=select(i,...)
	end
	local result = table.concat(printtmp," ",1,n);
	frame:AddMessage(result)
	
	local logs = CPUThievesDB.log
	logs.n = logs.n + 1
	if logs.n>1000 then
		logs.n=1
	end
	
	result = gsub(result, "|c[A-Fa-f0-9][A-Fa-f0-9][A-Fa-f0-9][A-Fa-f0-9][A-Fa-f0-9][A-Fa-f0-9][A-Fa-f0-9][A-Fa-f0-9]", "")
	result = gsub(result, "|r", "")
	logs[logs.n]=format("%s %s", _G.date("%H:%M:%S"), result)
end

local function printf(fmtOrFrame, ...)
	if (type(fmtOrFrame)=="table" and fmtOrFrame.AddMessage) or fmtOrFrame==nil then
		return print(fmtOrFrame,format(...))
	else
		return print(format(fmtOrFrame, ...))
	end
end


local isProfiling = GetScriptCPUUsage()>0	-- Is profiling enabled? (DON'T look at cvar, look at what's actually HAPPENING)


local pollAddOnCPU, pollFrameCPU, reportRecentCPU, initAddons, nowtolast
local outputStats

if isProfiling then
	local last = {}    -- ["AddonName"]=123 and [frame]=12
	local now = {}     -- ["AddonName"]=234 and [frame]=23
	local allAddons={} -- [1]="AddonName"

	local allFrames={}  -- [1]=frame
	
	initAddons = function()
		for i=1, GetNumAddOns() do
			local name = GetAddOnInfo(i)
			allAddons[i]=name
			now[name]=0
			last[name]=0
		end
	end
	

   
   -- GLOBALS: UpdateAddOnCPUUsage GetNumAddOns GetAddOnInfo IsAddOnLoaded GetAddOnCPUUsage

   pollAddOnCPU = function(report)
		UpdateAddOnCPUUsage()
		for k,v in pairs(allAddons) do
			now[v]=GetAddOnCPUUsage(v)
			if not last[v] then
				last[v]=0
			elseif report and now[v]-last[v]>100 then
				if v~="!CPUThieves" then
					printf(outputFrame,
						" %5.0f |cff808080%4.1fs|r %s", now[v]-last[v], now[v]/1000, v)
				end
				last[v]=now[v]
			end
		end
	end
	  
	local numFrames = 0
	local frame = nil
	local lastReportedFrameNow
	local numSame=0
	
	pollFrameCPU = function(report, pollAll)
		if pollAll or not frame then
			frame = EnumerateFrames()
			numFrames=0
		end
		while frame do
			numFrames=numFrames+1
			allFrames[numFrames]=frame
			now[frame]=GetFrameCPUUsage(frame,false)
			if not last[frame] then
				last[frame]=0
			elseif report and now[frame]-last[frame]>100 then
				-- Some LIMITED same-frame-handler resolution here. It only partially hides duplicates (due to wrongish sorting, and split scanning) but better than nothing.
				if lastReportedFrameNow == now[frame] then
					numSame = numSame + 1
				elseif numSame>0 then
					printf(outputFrame,
						"    |cffc0c0c0 .. and %u more frames with same handler function|r", numSame)
					numSame=0
				else
					lastReportedFrameNow = now[frame]
					local displayName = frame:GetName()
					if not displayName or displayName=="" then
						displayName=tostring(frame)
					end
					printf(outputFrame,
						" %5.0f |cff808080%4.1fs|r F:%s", now[frame]-last[frame], now[frame]/1000, displayName)
				end
				last[frame]=now[frame]
			end
			frame = EnumerateFrames(frame)
			if not frame then
				break
			end
			
			if not pollAll and numFrames%2000 == 0 then
				return false
			end
		end
		if numSame>0 then	-- will only ever be >0 if reporting is enabled
			printf(outputFrame,
			"    |cffc0c0c0 .. and %u more frames with same handler function|r", numSame)
			numSame=0
		end
		return true
	end


   local function recentCpuComparator(a,b)
	  if a then
        a=now[a]-last[a]
	  else 
	    a=0
	  end
	  if b then
        b=now[b]-last[b]
	  else
	    b=0
	  end
      return a>b
   end
   
   local function totalCpuComparator(a,b)
	  if a then
        a=max(now[a] or 0, last[a] or 0)
	  else 
	    a=0
	  end
	  if b then
        b=max(now[b] or 0, last[b] or 0)
	  else
	    b=0
	  end
      return a>b
   end
   
	reportRecentCPU = function()
		table.sort(allAddons, recentCpuComparator)
		for i=1,5 do
			local name=allAddons[i]
			if now[name]-last[name] < 20 then break end -- dont output <20ms, they're not to blame
			printf(outputFrame,
				" %5.0f |cff808080%4.1fs|r %s", now[name]-last[name], now[name]/1000, name)
		end
		table.sort(allFrames, recentCpuComparator)
		local i=0
		for shown=1,5 do
			i=i+1
			local name=allFrames[i]
			if now[name]-last[name] < 20 then break end -- dont output <20ms, they're not to blame
			local displayName = name:GetName()
			if not displayName or displayName=="" then
				displayName=tostring(name)
			end
			-- find more frames with same handler func, which will be reported as ALSO taking the same time
			local numSame=0
			while now[allFrames[i+1]]==now[name] do
				numSame=numSame+1
				i=i+1
			end
			
			printf(outputFrame,
				" %5.0f |cff808080%4.1fs|r F:%s", now[name]-last[name], now[name]/1000, displayName)
			if numSame>0 then
				printf(outputFrame,
				"    |cffc0c0c0 .. and %u more frames with same handler function|r", numSame)
			end
			
		end
		
   end
   
   
   local function totalCpuComparator(a,b)
	  if a then
        a=max(now[a] or 0, last[a] or 0)
	  else 
	    a=0
	  end
	  if b then
        b=max(now[b] or 0, last[b] or 0)
	  else
	    b=0
	  end
      return a>b
	end
   

	outputStats = function()
		printf("Tracking total %u addons, %u frames", #allAddons, #allFrames)
		table.sort(allAddons, totalCpuComparator)
		print("Addons by total CPU:")
		for i=1,7 do
			local name=allAddons[i]
			printf(
				" |cffffff80%4.1fs|r %s", now[name]/1000, name)
		end
		table.sort(allFrames, totalCpuComparator)
		print("Frames by total CPU:")
		local i=0
		for shown=1,7 do
			i=i+1
			local name=allFrames[i]
			local displayName = name:GetName()
			if not displayName or displayName=="" then
				displayName=tostring(name)
			end
			-- find more frames with same handler func, which will be reported as ALSO taking the same time
			local numSame=0
			while now[allFrames[i+1]]==now[name] do
				numSame=numSame+1
				i=i+1
			end
			
			printf(
				" |cffffff80%4.1fs|r F:%s", now[name]/1000, displayName)
			if numSame>0 then
				printf(
				"    |cffc0c0c0 .. and %u more frames with same handler function|r", numSame)
			end
			
		end
	end   

	nowtolast = function()
		now,last = last,now	
	end
	
else
	pollAddOnCPU = function()
	end
	reportRecentCPU = function()
	end
	pollFrameCPU = function()
		return true	-- immediately done
	end
	initAddons = function()
	end
	nowtolast = function()
	end
	outputStats = function()
		print("CPU profiling is not enabled - no stats to show.")
	end
end



local frame = CreateFrame("Frame", "CPUThievesFrame")

local lastTime = debugprofilestop()
local lastScriptCPUUsage = GetScriptCPUUsage()
local pollingCycle=0
local myUsage = 0
local myUsageNum = 1
local myWorstUsage = 0
local reportOnNextFrame = false

-- GLOBALS: GetScriptCPUUsage

local function onUpdate()
	local nowTime = debugprofilestop()
	local nowScriptCPUUsage = GetScriptCPUUsage()
	
	if nowTime-lastTime > (InCombatLockdown() and 150 or 300) then  -- UI errors out on 200+ ms in combat
		local hickup = nowTime-lastTime
		local addons = nowScriptCPUUsage-lastScriptCPUUsage
		local r,g,b = 0xff,0xff,0xff
		if addons/hickup > 0.2 then
		  b=32
		end
		if addons/hickup > 0.7 then
		  g=32
		end
		printf(outputFrame,
			"Detected %.0fms FPS hickup%s. (|cff%02x%02x%02x%.0fms = Lua|r)",
			hickup,
			InCombatLockdown() and " DURING COMBAT" or "",
			r,g,b,
			addons
		)
		reportOnNextFrame = true	-- we can't report now, we'd hit the 200ms limit (if this is during combat)
		
	elseif reportOnNextFrame then
		reportOnNextFrame = false
		-- Poll everything
		pollAddOnCPU(false)
		pollFrameCPU(false,true)
		-- Report
		reportRecentCPU()
		-- Start polling normally again
		pollingCycle=0
		nowtolast()
	else
		if pollingCycle==0 then
			pollAddOnCPU(true)
			pollingCycle=1
		else
			local polledAll = pollFrameCPU(true)
			if polledAll then
				pollingCycle=0
				nowtolast()
			else
				pollingCycle=pollingCycle+1
			end
		end
		
		-- Do some stats on how much CPU CPUThieves itself eats (polling only)
		local thisUsage = debugprofilestop()-nowTime
		myUsage = myUsage + thisUsage
		myUsageNum = myUsageNum + 1
		if thisUsage > myWorstUsage then
			myWorstUsage = thisUsage
		end
	end
	
	-- Get ready for next pass
	lastTime=debugprofilestop()
	lastScriptCPUUsage = GetScriptCPUUsage()
	
end





frame:SetScript("OnUpdate", function()  -- only happens on 1st OnUpdate, gets re-pointed
	CPUThievesDB = CPUThievesDB or {}
	CPUThievesDB.log = CPUThievesDB.log or {}
	CPUThievesDB.log.n = CPUThievesDB.log.n or 0
	
	if type(_G[CPUThievesDB.chatFrame])=="table" and _G[CPUThievesDB.chatFrame].AddMessage then
		outputFrame = _G[CPUThievesDB.chatFrame]
	end

	initAddons()
	
	-- First, poll all current Addon & Frame CPU usages so we have a baseline
	pollAddOnCPU()
	pollFrameCPU(false, true)
	nowtolast()
	
	frame:SetScript("OnUpdate", onUpdate)
end)
frame:Show()


_G.SLASH_CPUTHIEVES1 = "/cputhieves"
_G.SLASH_CPUTHIEVES2 = "/cpu"
-- GLOBALS: SetCVar, ResetCPUUsage

SlashCmdList["CPUTHIEVES"] = function(arg)
	if strmatch(arg,"^enable") then
		SetCVar("scriptProfile", 1)
		if isProfiling then
			print("Profiling is enabled.")
		else
			print("Reload UI to ENABLE PROFILING.")
		end
		
	elseif strmatch(arg,"^disable") then
		SetCVar("scriptProfile", 0)
		if not isProfiling then
			print("Profiling is disabled.")
		else
			print("Reload UI to DISABLE PROFILING.")
		end
		
		
		
	elseif strmatch(arg,"^output") then
	    local dest = strmatch(arg,"^output +([_A-Za-z0-9]+)")
		if type(_G[dest])=="table" and _G[dest].AddMessage then
			CPUThievesDB.chatFrame = dest
			outputFrame = _G[dest]
		else
			print("Usage: /cpu output ChatFrame#   (or anything with an .AddMessage)")
			-- GLOBALS: GetChatWindowInfo
			for i=1,9 do 
				local f=_G["ChatFrame"..i]
				local title=GetChatWindowInfo(i)
				if type(f)=="table" and f.AddMessage and title and title~="" then	
					print("  ChatFrame"..i..": "..GetChatWindowInfo(i))
				end
			end
		end
		
		
	elseif strmatch(arg,"^stats") then
		outputStats()
		printf("CPUThieves uses about %.1fms per frame. Worst seen: %.1fms", (myUsage/myUsageNum), myWorstUsage)
		
	elseif strmatch(arg, "^reset") then
		ResetCPUUsage();
		-- Re-poll everything (without reporting)
		pollAddOnCPU(false)
		pollFrameCPU(false, true)
		nowtolast()
		pollingCycle=0
		
	
	else
		print("Usage:")
		print("  enable - toggle profiling ON, needs reload")
		print("  disable - toggle profiling OFF, needs reload")
		print("  output - which chatframe to send live reporting to")
		print("  stats - top 7 CPU using addons&frames")
		print("  reset - reset all CPU usage counters")
		
		printf("CPU profiling is currently %s.", isProfiling and "ENABLED" or "DISABLED")
	end
end
